ONX_Model Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_extensions.h>`

## Public Member Functions

| ONX_Model ()
virtual | ~ONX_Model ()
void | Destroy ()
bool | Read (ON_BinaryArchive &archive, ON_TextLog *error_log=NULL)
bool | Read (const char *filename, ON_TextLog *error_log=NULL)
bool | Read (const wchar_t *filename, ON_TextLog *error_log=NULL)
bool | Write (ON_BinaryArchive &archive, int version=0, const char *sStartSectionComment=NULL, ON_TextLog *error_log=NULL)
bool | Write (const char *filename, int version=0, const char *sStartSectionComment=NULL, ON_TextLog *error_log=NULL)
bool | Write (const wchar_t *filename, int version=0, const char *sStartSectionComment=NULL, ON_TextLog *error_log=NULL)
bool | IsValid (ON_TextLog *text_log=NULL) const
virtual void | Polish ()
virtual int | Audit (bool bAttemptRepair, int *repair_count, ON_TextLog *text_log, ON_SimpleArray< int > *warnings)
ON_BoundingBox | BoundingBox () const
void | GetRenderMaterial (const ON_3dmObjectAttributes &attributes, ON_Material &material) const
void | GetRenderMaterial (int object_index, ON_Material &material) const
void | GetLinetype (const ON_3dmObjectAttributes &attributes, ON_Linetype &linetype) const
void | GetLinetype (int object_index, ON_Linetype &linetype) const
ON_Color | WireframeColor (const ON_3dmObjectAttributes &attributes) const
ON_Color | WireframeColor (int object_index) const
virtual int | ObjectIndex (ON_UUID object_uuid) const
virtual int | IDefIndex (ON_UUID idef_uuid) const
virtual int | IDefIndex (const wchar_t *idef_name) const
virtual void | GetUnusedIDefName (ON_wString &idef_name) const
virtual int | UsesIDef (const ON_InstanceRef &iref, ON_UUID idef_uuid) const
virtual int | LayerIndex (const wchar_t *layer_name) const
virtual void | GetUnusedLayerName (ON_wString &layer_name) const
bool | SetDocumentUserString (const wchar_t *key, const wchar_t *string_value)
bool | GetDocumentUserString (const wchar_t *key, ON_wString &string_value) const
int | GetDocumentUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
void | Dump (ON_TextLog &) const
void | DumpSummary (ON_TextLog &) const
void | DumpBitmapTable (ON_TextLog &) const
void | DumpTextureMappingTable (ON_TextLog &) const
void | DumpMaterialTable (ON_TextLog &) const
void | DumpLinetypeTable (ON_TextLog &) const
void | DumpLayerTable (ON_TextLog &) const
void | DumpLightTable (ON_TextLog &) const
void | DumpGroupTable (ON_TextLog &) const
void | DumpFontTable (ON_TextLog &) const
void | DumpDimStyleTable (ON_TextLog &) const
void | DumpHatchPatternTable (ON_TextLog &) const
void | DumpIDefTable (ON_TextLog &) const
void | DumpObjectTable (ON_TextLog &) const
void | DumpHistoryRecordTable (ON_TextLog &) const
void | DumpUserDataTable (ON_TextLog &) const
void | DestroyCache ()

## Static Public Member Functions

static bool | IsRDKDocumentInformation (const ONX_Model_UserData &docud)
static bool | GetRDKDocumentInformation (const ONX_Model_UserData &docud, ON_wString &rdk_xml_document_data)
static bool | IsRDKObjectInformation (const ON_UserData &objectud)
static bool | GetRDKObjectInformation (const ON_Object &object, ON_wString &rdk_xml_object_data)

## Public Attributes

int | m_3dm_file_version
int | m_3dm_opennurbs_version
ON_String | m_sStartSectionComments
ON_3dmProperties | m_properties
ON_3dmSettings | m_settings
ON_SimpleArray< ON_Bitmap * > | m_bitmap_table
ON_ObjectArray< ON_TextureMapping > | m_mapping_table
ON_ObjectArray< ON_Material > | m_material_table
ON_ObjectArray< ON_Linetype > | m_linetype_table
ON_ObjectArray< ON_Layer > | m_layer_table
ON_ObjectArray< ON_Group > | m_group_table
ON_ObjectArray< ON_Font > | m_font_table
ON_ObjectArray< ON_DimStyle > | m_dimstyle_table
ON_ClassArray< ONX_Model_RenderLight > | m_light_table
ON_ObjectArray< ON_HatchPattern > | m_hatch_pattern_table
ON_ObjectArray< ON_InstanceDefinition > | m_idef_table
ON_ClassArray< ONX_Model_Object > | m_object_table
ON_SimpleArray< ON_HistoryRecord * > | m_history_record_table
ON_ClassArray< ONX_Model_UserData > | m_userdata_table
ON_UuidIndexList | m_mapping_id_index
ON_UuidIndexList | m_material_id_index
ON_UuidIndexList | m_object_id_index
ON_UuidIndexList | m_idef_id_index
size_t | m_file_length
int | m_crc_error_count

## Detailed Description

Definition at line 177 of file opennurbs_extensions.h.

## Constructor & Destructor Documentation

## ONX_Model()

ONX_Model::ONX_Model | ( |  | ) |

## ~ONX_Model()

virtual ONX_Model::~ONX_Model | ( |  | ) |

virtual

## Member Function Documentation

## Audit()

virtual int ONX_Model::Audit | ( | bool | bAttemptRepair,
|  | int * | repair_count,
|  | ON_TextLog * | text_log,
|  | ON_SimpleArray< int > * | warnings
| ) |  |

virtual

## BoundingBox()

ON_BoundingBox ONX_Model::BoundingBox | ( |  | ) | const

## Destroy()

void ONX_Model::Destroy | ( |  | ) |

## DestroyCache()

void ONX_Model::DestroyCache | ( |  | ) |

## Dump()

void ONX_Model::Dump | ( | ON_TextLog & |  | ) | const

## DumpBitmapTable()

void ONX_Model::DumpBitmapTable | ( | ON_TextLog & |  | ) | const

## DumpDimStyleTable()

void ONX_Model::DumpDimStyleTable | ( | ON_TextLog & |  | ) | const

## DumpFontTable()

void ONX_Model::DumpFontTable | ( | ON_TextLog & |  | ) | const

## DumpGroupTable()

void ONX_Model::DumpGroupTable | ( | ON_TextLog & |  | ) | const

## DumpHatchPatternTable()

void ONX_Model::DumpHatchPatternTable | ( | ON_TextLog & |  | ) | const

## DumpHistoryRecordTable()

void ONX_Model::DumpHistoryRecordTable | ( | ON_TextLog & |  | ) | const

## DumpIDefTable()

void ONX_Model::DumpIDefTable | ( | ON_TextLog & |  | ) | const

## DumpLayerTable()

void ONX_Model::DumpLayerTable | ( | ON_TextLog & |  | ) | const

## DumpLightTable()

void ONX_Model::DumpLightTable | ( | ON_TextLog & |  | ) | const

## DumpLinetypeTable()

void ONX_Model::DumpLinetypeTable | ( | ON_TextLog & |  | ) | const

## DumpMaterialTable()

void ONX_Model::DumpMaterialTable | ( | ON_TextLog & |  | ) | const

## DumpObjectTable()

void ONX_Model::DumpObjectTable | ( | ON_TextLog & |  | ) | const

## DumpSummary()

void ONX_Model::DumpSummary | ( | ON_TextLog & |  | ) | const

## DumpTextureMappingTable()

void ONX_Model::DumpTextureMappingTable | ( | ON_TextLog & |  | ) | const

## DumpUserDataTable()

void ONX_Model::DumpUserDataTable | ( | ON_TextLog & |  | ) | const

## GetDocumentUserString()

bool ONX_Model::GetDocumentUserString | ( | const wchar_t * | key,
|  | ON_wString & | string_value
| ) |  | const

## GetDocumentUserStrings()

int ONX_Model::GetDocumentUserStrings | ( | ON_ClassArray< ON_UserString > & | user_strings | ) | const

## GetLinetype() [1/2]

void ONX_Model::GetLinetype | ( | const ON_3dmObjectAttributes & | attributes,
|  | ON_Linetype & | linetype
| ) |  | const

## GetLinetype() [2/2]

void ONX_Model::GetLinetype | ( | int | object_index,
|  | ON_Linetype & | linetype
| ) |  | const

## GetRDKDocumentInformation()

static bool ONX_Model::GetRDKDocumentInformation | ( | const ONX_Model_UserData & | docud,
|  | ON_wString & | rdk_xml_document_data
| ) |  |

static

## GetRDKObjectInformation()

static bool ONX_Model::GetRDKObjectInformation | ( | const ON_Object & | object,
|  | ON_wString & | rdk_xml_object_data
| ) |  |

static

## GetRenderMaterial() [1/2]

void ONX_Model::GetRenderMaterial | ( | const ON_3dmObjectAttributes & | attributes,
|  | ON_Material & | material
| ) |  | const

## GetRenderMaterial() [2/2]

void ONX_Model::GetRenderMaterial | ( | int | object_index,
|  | ON_Material & | material
| ) |  | const

## GetUnusedIDefName()

virtual void ONX_Model::GetUnusedIDefName | ( | ON_wString & | idef_name | ) | const

virtual

## GetUnusedLayerName()

virtual void ONX_Model::GetUnusedLayerName | ( | ON_wString & | layer_name | ) | const

virtual

## IDefIndex() [1/2]

virtual int ONX_Model::IDefIndex | ( | ON_UUID | idef_uuid | ) | const

virtual

## IDefIndex() [2/2]

virtual int ONX_Model::IDefIndex | ( | const wchar_t * | idef_name | ) | const

virtual

## IsRDKDocumentInformation()

static bool ONX_Model::IsRDKDocumentInformation | ( | const ONX_Model_UserData & | docud | ) |

static

## IsRDKObjectInformation()

static bool ONX_Model::IsRDKObjectInformation | ( | const ON_UserData & | objectud | ) |

static

## IsValid()

bool ONX_Model::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

## LayerIndex()

virtual int ONX_Model::LayerIndex | ( | const wchar_t * | layer_name | ) | const

virtual

## ObjectIndex()

virtual int ONX_Model::ObjectIndex | ( | ON_UUID | object_uuid | ) | const

virtual

## Polish()

virtual void ONX_Model::Polish | ( |  | ) |

virtual

## Read() [1/3]

bool ONX_Model::Read | ( | ON_BinaryArchive & | archive,
|  | ON_TextLog * | error_log = `NULL`
| ) |  |

## Read() [2/3]

bool ONX_Model::Read | ( | const char * | filename,
|  | ON_TextLog * | error_log = `NULL`
| ) |  |

## Read() [3/3]

bool ONX_Model::Read | ( | const wchar_t * | filename,
|  | ON_TextLog * | error_log = `NULL`
| ) |  |

## SetDocumentUserString()

bool ONX_Model::SetDocumentUserString | ( | const wchar_t * | key,
|  | const wchar_t * | string_value
| ) |  |

## UsesIDef()

virtual int ONX_Model::UsesIDef | ( | const ON_InstanceRef & | iref,
|  | ON_UUID | idef_uuid
| ) |  | const

virtual

## WireframeColor() [1/2]

ON_Color ONX_Model::WireframeColor | ( | const ON_3dmObjectAttributes & | attributes | ) | const

## WireframeColor() [2/2]

ON_Color ONX_Model::WireframeColor | ( | int | object_index | ) | const

## Write() [1/3]

bool ONX_Model::Write | ( | ON_BinaryArchive & | archive,
|  | int | version = `0`,
|  | const char * | sStartSectionComment = `NULL`,
|  | ON_TextLog * | error_log = `NULL`
| ) |  |

## Write() [2/3]

bool ONX_Model::Write | ( | const char * | filename,
|  | int | version = `0`,
|  | const char * | sStartSectionComment = `NULL`,
|  | ON_TextLog * | error_log = `NULL`
| ) |  |

## Write() [3/3]

bool ONX_Model::Write | ( | const wchar_t * | filename,
|  | int | version = `0`,
|  | const char * | sStartSectionComment = `NULL`,
|  | ON_TextLog * | error_log = `NULL`
| ) |  |

## Member Data Documentation

## m_3dm_file_version

int ONX_Model::m_3dm_file_version

Definition at line 439 of file opennurbs_extensions.h.

## m_3dm_opennurbs_version

int ONX_Model::m_3dm_opennurbs_version

Definition at line 440 of file opennurbs_extensions.h.

## m_bitmap_table

ON_SimpleArray<ON_Bitmap*> ONX_Model::m_bitmap_table

Definition at line 452 of file opennurbs_extensions.h.

## m_crc_error_count

int ONX_Model::m_crc_error_count

Definition at line 478 of file opennurbs_extensions.h.

## m_dimstyle_table

ON_ObjectArray<ON_DimStyle> ONX_Model::m_dimstyle_table

Definition at line 459 of file opennurbs_extensions.h.

## m_file_length

size_t ONX_Model::m_file_length

Definition at line 474 of file opennurbs_extensions.h.

## m_font_table

ON_ObjectArray<ON_Font> ONX_Model::m_font_table

Definition at line 458 of file opennurbs_extensions.h.

## m_group_table

ON_ObjectArray<ON_Group> ONX_Model::m_group_table

Definition at line 457 of file opennurbs_extensions.h.

## m_hatch_pattern_table

ON_ObjectArray<ON_HatchPattern> ONX_Model::m_hatch_pattern_table

Definition at line 461 of file opennurbs_extensions.h.

## m_history_record_table

ON_SimpleArray<ON_HistoryRecord*> ONX_Model::m_history_record_table

Definition at line 464 of file opennurbs_extensions.h.

## m_idef_id_index

ON_UuidIndexList ONX_Model::m_idef_id_index

Definition at line 471 of file opennurbs_extensions.h.

## m_idef_table

ON_ObjectArray<ON_InstanceDefinition> ONX_Model::m_idef_table

Definition at line 462 of file opennurbs_extensions.h.

## m_layer_table

ON_ObjectArray<ON_Layer> ONX_Model::m_layer_table

Definition at line 456 of file opennurbs_extensions.h.

## m_light_table

ON_ClassArray<ONX_Model_RenderLight> ONX_Model::m_light_table

Definition at line 460 of file opennurbs_extensions.h.

## m_linetype_table

ON_ObjectArray<ON_Linetype> ONX_Model::m_linetype_table

Definition at line 455 of file opennurbs_extensions.h.

## m_mapping_id_index

ON_UuidIndexList ONX_Model::m_mapping_id_index

Definition at line 468 of file opennurbs_extensions.h.

## m_mapping_table

ON_ObjectArray<ON_TextureMapping> ONX_Model::m_mapping_table

Definition at line 453 of file opennurbs_extensions.h.

## m_material_id_index

ON_UuidIndexList ONX_Model::m_material_id_index

Definition at line 469 of file opennurbs_extensions.h.

## m_material_table

ON_ObjectArray<ON_Material> ONX_Model::m_material_table

Definition at line 454 of file opennurbs_extensions.h.

## m_object_id_index

ON_UuidIndexList ONX_Model::m_object_id_index

Definition at line 470 of file opennurbs_extensions.h.

## m_object_table

ON_ClassArray<ONX_Model_Object> ONX_Model::m_object_table

Definition at line 463 of file opennurbs_extensions.h.

## m_properties

ON_3dmProperties ONX_Model::m_properties

Definition at line 445 of file opennurbs_extensions.h.

## m_settings

ON_3dmSettings ONX_Model::m_settings

Definition at line 449 of file opennurbs_extensions.h.

## m_sStartSectionComments

ON_String ONX_Model::m_sStartSectionComments

Definition at line 441 of file opennurbs_extensions.h.

## m_userdata_table

ON_ClassArray<ONX_Model_UserData> ONX_Model::m_userdata_table

Definition at line 465 of file opennurbs_extensions.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_extensions.h